## org.firebirdsql.jdbc
Class AbstractConnection

    java.lang.Object
      org.firebirdsql.jdbc.AbstractConnection

All Implemented Interfaces:
  Connection, Wrapper, FirebirdConnection

Direct Known Subclasses:
  FBConnection

    public abstract class AbstractConnection

extends Object
implements FirebirdConnection

The class `AbstractConnection` is a handle to a `FBManagedConnection`.

Version:
  1.0
Author:
  David Jencks

Field Summary
`protected FBManagedConnection` `mc`
`protected InternalTransactionCoordinator` `txCoordinator`

Fields inherited from interface org.firebirdsql.jdbc.FirebirdConnection
`TPB_CONCURRENCY, TPB_CONSISTENCY, TPB_NO_REC_VERSION, TPB_NOWAIT, TPB_READ, TPB_READ_COMMITTED, TPB_REC_VERSION, TPB_WAIT, TPB_WRITE`

Fields inherited from interface java.sql.Connection
`TRANSACTION_NONE, TRANSACTION_READ_COMMITTED, TRANSACTION_READ_UNCOMMITTED, TRANSACTION_REPEATABLE_READ, TRANSACTION_SERIALIZABLE`

Constructor Summary
`AbstractConnection(FBManagedConnection mc)` Create a new AbstractConnection instance based on a `FBManagedConnection`.

Method Summary
`protected void` `addWarning(SQLWarning warning)`
`void` `clearWarnings()` Clears all warnings reported for this `Connection` object.
`void` `close()` Releases a Connection's database and JDBC resources immediately instead of waiting for them to be automatically released.
`void` `commit()` Makes all changes made since the previous commit/rollback permanent and releases any database locks currently held by the Connection.
`Blob` `createBlob()` This non-interface method is included so you can actually get a blob object to use to write new data into a blob field without needing a preexisting blob to modify.
`Statement` `createStatement()` Creates a `Statement` object for sending SQL statements to the database.
`Statement` `createStatement(int resultSetType, int resultSetConcurrency)` Creates a `Statement` object that will generate `ResultSet` objects with the given type and concurrency.
`Statement` `createStatement(int resultSetType, int resultSetConcurrency, int resultSetHoldability)` Creates a `Statement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability.
`TransactionParameterBuffer` `createTransactionParameterBuffer()` Create new instance of `TransactionParameterBuffer`.
`protected void` `finalize()`
`boolean` `getAutoCommit()` Gets the current auto-commit state.
`String` `getCatalog()` Returns the Connection's current catalog name.
`DatabaseParameterBuffer` `getDatabaseParameterBuffer()` Get database parameter buffer for this connection.
`GDSHelper` `getGDSHelper()`
`int` `getHoldability()` Retrieves the current holdability of `ResultSet` objects created using this `Connection` object.
`GDS` `getInternalAPIHandler()` Get Firebird API handler (sockets/native/embeded/etc)
`IscDbHandle` `getIscDBHandle()` Get connection handle for direct Firebird API access
`String` `getIscEncoding()` Get the encoding that is being used for this connection.
`FirebirdLocalTransaction` `getLocalTransaction()` Returns a FBLocalTransaction instance that enables a component to demarcate resource manager local transactions on this connection.
`DatabaseMetaData` `getMetaData()` Gets the metadata regarding this connection's database.
`FBObjectListener.StatementListener` `getStatementListener()`
`int` `getTransactionIsolation()` Gets this Connection's current transaction isolation level.
`TransactionParameterBuffer` `getTransactionParameters(int isolationLevel)` Get transaction parameters for the specified transaction isolation level.
`Map` `getTypeMap()` Gets the type map object associated with this connection.
`SQLWarning` `getWarnings()` Returns the first warning reported by calls on this Connection.
`boolean` `inTransaction()` Check if this connection is currently involved in a transaction
`protected void` `invalidateSavepoints()` Invalidate all savepoints.
`boolean` `isClosed()` Tests to see if a Connection is closed.
`boolean` `isReadOnly()` Tests to see if the connection is in read-only mode.
`String` `nativeSQL(String sql)` Converts the given SQL statement into the system's native SQL grammar.
`CallableStatement` `prepareCall(String sql)` Creates a `CallableStatement` object for calling database stored procedures.
`CallableStatement` `prepareCall(String sql, int resultSetType, int resultSetConcurrency)` Creates a `CallableStatement` object that will generate `ResultSet` objects with the given type and concurrency.
`CallableStatement` `prepareCall(String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability)`
`PreparedStatement` `prepareStatement(String sql)` Creates a `PreparedStatement` object for sending parameterized SQL statements to the database.
`PreparedStatement` `prepareStatement(String sql, int resultSetType, int resultSetConcurrency)` Creates a `PreparedStatement` object that will generate `ResultSet` objects with the given type and concurrency.
`PreparedStatement` `prepareStatement(String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability)`
`PreparedStatement` `prepareStatement(String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability, boolean metaData)`
`void` `releaseSavepoint(FirebirdSavepoint savepoint)` Removes the given `Savepoint` object from the current transaction.
`void` `rollback()` Drops all changes made since the previous commit/rollback and releases any database locks currently held by this Connection.
`void` `rollback(FirebirdSavepoint savepoint)` Undoes all changes made after the given `Savepoint` object was set.
`void` `setAutoCommit(boolean autoCommit)` Sets this connection's auto-commit mode.
`void` `setCatalog(String catalog)` Sets a catalog name in order to select a subspace of this Connection's database in which to work.
`FirebirdSavepoint` `setFirebirdSavepoint()` Creates an unnamed savepoint in the current transaction and returns the new `Savepoint` object that represents it.
`FirebirdSavepoint` `setFirebirdSavepoint(String name)` Creates a savepoint with the given name in the current transaction and returns the new `Savepoint` object that represents it.
`void` `setHoldability(int holdability)` Changes the holdability of `ResultSet` objects created using this `Connection` object to the given holdability.
`void` `setManagedConnection(FBManagedConnection mc)` Set the `FBManagedConnection` around which this connection is based.
`void` `setManagedEnvironment(boolean managedConnection)`
`void` `setReadOnly(boolean readOnly)` Puts this connection in read-only mode as a hint to enable database optimizations.
`void` `setTransactionIsolation(int level)` Attempts to change the transaction isolation level to the one given.
`void` `setTransactionParameters(int isolationLevel, int[] parameters)` Set transaction parameters for the specified isolation level.
`void` `setTransactionParameters(int isolationLevel, TransactionParameterBuffer tpb)` Set transaction parameters for the specified transaction isolation level.
`void` `setTransactionParameters(TransactionParameterBuffer tpb)` Set transaction parameters for the next transactions.
`void` `setTypeMap(Map map)` Installs the given type map as the type map for this connection.

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface java.sql.Connection
`createArrayOf, createClob, createNClob, createSQLXML, createStruct, getClientInfo, getClientInfo, isValid, prepareStatement, prepareStatement, prepareStatement, releaseSavepoint, rollback, setClientInfo, setClientInfo, setSavepoint, setSavepoint`

Methods inherited from interface java.sql.Wrapper
`isWrapperFor, unwrap`

Field Detail

### mc

    protected FBManagedConnection mc

### txCoordinator

    protected InternalTransactionCoordinator txCoordinator

Constructor Detail

### AbstractConnection

    public AbstractConnection(FBManagedConnection mc)

  Create a new AbstractConnection instance based on a `FBManagedConnection`.

  Parameters:
    `mc` - A FBManagedConnection around which this connection is based

Method Detail

### getStatementListener

    public FBObjectListener.StatementListener getStatementListener()

### getHoldability

    public int getHoldability()
                       throws SQLException

  Description copied from interface: `FirebirdConnection`
  Retrieves the current holdability of `ResultSet` objects created using this `Connection` object.

  Method copied from the JDBC 3.0 specification.

  Specified by:
    `getHoldability` in interface `Connection`
  Specified by:
    `getHoldability` in interface `FirebirdConnection`
  Returns:
    the holdability, one of `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
  Throws:
    `SQLException` - if a database access occurs
  See Also:
    `FirebirdConnection.setHoldability(int)`, `ResultSet`

### setHoldability

    public void setHoldability(int holdability)
                        throws SQLException

  Description copied from interface: `FirebirdConnection`
  Changes the holdability of `ResultSet` objects created using this `Connection` object to the given holdability.

  Method copied from the JDBC 3.0 specification.

  Specified by:
    `setHoldability` in interface `Connection`
  Specified by:
    `setHoldability` in interface `FirebirdConnection`
  Parameters:
    `holdability` - a `ResultSet` holdability constant; one of `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
  Throws:
    `SQLException` - if a database access occurs, the given parameter is not a `ResultSet` constant indicating holdability, or the given holdability is not supported
  See Also:
    `FirebirdConnection.getHoldability()`, `ResultSet`

### setManagedConnection

    public void setManagedConnection(FBManagedConnection mc)

  Set the `FBManagedConnection` around which this connection is based.

  Parameters:
    `mc` - The FBManagedConnection around which this connection is based

### getIscDBHandle

    public IscDbHandle getIscDBHandle()
                               throws GDSException

  Get connection handle for direct Firebird API access

  Returns:
    internal handle for connection
  Throws:
    `GDSException` - if handle needed to be created and creation failed

### getInternalAPIHandler

    public GDS getInternalAPIHandler()
                              throws SQLException

  Get Firebird API handler (sockets/native/embeded/etc)

  Returns:
    handler object for internal API calls
  Throws:
    `SQLException`

### getDatabaseParameterBuffer

    public DatabaseParameterBuffer getDatabaseParameterBuffer()

  Get database parameter buffer for this connection.

  Returns:
    instance of `DatabaseParameterBuffer`.

### setTransactionParameters

    public void setTransactionParameters(int isolationLevel,
                                         int[] parameters)
                                  throws SQLException

  Description copied from interface: `FirebirdConnection`
  Set transaction parameters for the specified isolation level. They will take effect only on the newly started transaction.

  Specified by:
    `setTransactionParameters` in interface `FirebirdConnection`
  Parameters:
    `isolationLevel` - JDBC isolation level.
    `parameters` - array of TPB parameters, see all TPB_* constants.
  Throws:
    `SQLException` - if specified transaction parameters cannot be set.

### getTransactionParameters

    public TransactionParameterBuffer getTransactionParameters(int isolationLevel)
                                                        throws SQLException

  Description copied from interface: `FirebirdConnection`
  Get transaction parameters for the specified transaction isolation level.

  Specified by:
    `getTransactionParameters` in interface `FirebirdConnection`
  Parameters:
    `isolationLevel` - isolation level defined in the `Connection` interface.
  Returns:
    instance of `TransactionParameterBuffer` containing current transaction parameters.
  Throws:
    `SQLException` - if error occured obtaining transaction parameters.

### createTransactionParameterBuffer

    public TransactionParameterBuffer createTransactionParameterBuffer()
                                                                throws SQLException

  Description copied from interface: `FirebirdConnection`
  Create new instance of `TransactionParameterBuffer`.

  Specified by:
    `createTransactionParameterBuffer` in interface `FirebirdConnection`
  Returns:
    empty instance of `TransactionParameterBuffer`.
  Throws:
    `SQLException` - if error occured during this operation.

### setTransactionParameters

    public void setTransactionParameters(int isolationLevel,
                                         TransactionParameterBuffer tpb)
                                  throws SQLException

  Description copied from interface: `FirebirdConnection`
  Set transaction parameters for the specified transaction isolation level. This method replaces the default TPB mapping with the specified one, changes will be effective from the next transaction start.

  Specified by:
    `setTransactionParameters` in interface `FirebirdConnection`
  Parameters:
    `isolationLevel` - isolation level defined in the `Connection` interface.
    `tpb` - instance of `TransactionParameterBuffer` with parameters to set.
  Throws:
    `SQLException` - if error occured during this operation.

### setTransactionParameters

    public void setTransactionParameters(TransactionParameterBuffer tpb)
                                  throws SQLException

  Description copied from interface: `FirebirdConnection`
  Set transaction parameters for the next transactions. This method does not change the TPB mapping, but replaces the mapping for the current transaction isolation until `Connection.setTransactionIsolation(int)` is called.

  Method cannot be called when transaction has already started.

  Specified by:
    `setTransactionParameters` in interface `FirebirdConnection`
  Parameters:
    `tpb` - instance of `TransactionParameterBuffer` with new transaction parameters.
  Throws:
    `SQLException` - if method is called within a transaction.

### createStatement

    public Statement createStatement()
                              throws SQLException

  Creates a `Statement` object for sending SQL statements to the database. SQL statements without parameters are normally executed using Statement objects. If the same SQL statement is executed many times, it is more efficient to use a `PreparedStatement` object.

  Result sets created using the returned `Statement` object will by default have forward-only type and read-only concurrency.

  Specified by:
    `createStatement` in interface `Connection`
  Returns:
    a new Statement object
  Throws:
    `SQLException` - if a database access error occurs

### prepareStatement

    public PreparedStatement prepareStatement(String sql)
                                       throws SQLException

  Creates a `PreparedStatement` object for sending parameterized SQL statements to the database. A SQL statement with or without IN parameters can be pre-compiled and stored in a PreparedStatement object. This object can then be used to efficiently execute this statement multiple times.

  Note: This method is optimized for handling parametric SQL statements that benefit from precompilation. If the driver supports precompilation, the method `prepareStatement` will send the statement to the database for precompilation. Some drivers may not support precompilation. In this case, the statement may not be sent to the database until the `PreparedStatement` is executed. This has no direct effect on users; however, it does affect which method throws certain SQLExceptions. Result sets created using the returned PreparedStatement will have forward-only type and read-only concurrency, by default.

  Specified by:
    `prepareStatement` in interface `Connection`
  Parameters:
    `sql` - a SQL statement that may contain one or more '?' IN parameter placeholders
  Returns:
    a new PreparedStatement object containing the pre-compiled statement
  Throws:
    `SQLException` - if a database access error occurs

### prepareCall

    public CallableStatement prepareCall(String sql)
                                  throws SQLException

  Creates a `CallableStatement` object for calling database stored procedures. The `CallableStatement` object provides methods for setting up its IN and OUT parameters, and methods for executing the call to a stored procedure.

  Note: This method is optimized for handling stored procedure call statements. Some drivers may send the call statement to the database when the method `prepareCall` is done; others may wait until the `CallableStatement` object is executed. This has no direct effect on users; however, it does affect which method throws certain SQLExceptions. Result sets created using the returned CallableStatement will have forward-only type and read-only concurrency, by default.

  Specified by:
    `prepareCall` in interface `Connection`
  Parameters:
    `sql` - a SQL statement that may contain one or more '?' parameter placeholders. Typically this statement is a JDBC function call escape string.
  Returns:
    a new CallableStatement object containing the pre-compiled SQL statement
  Throws:
    `SQLException` - if a database access error occurs

### nativeSQL

    public String nativeSQL(String sql)
                     throws SQLException

  Converts the given SQL statement into the system's native SQL grammar. A driver may convert the JDBC sql grammar into its system's native SQL grammar prior to sending it; this method returns the native form of the statement that the driver would have sent.

  Specified by:
    `nativeSQL` in interface `Connection`
  Parameters:
    `sql` - a SQL statement that may contain one or more '?' parameter placeholders
  Returns:
    the native form of this statement
  Throws:
    `SQLException` - if a database access error occurs

### setAutoCommit

    public void setAutoCommit(boolean autoCommit)
                       throws SQLException

  Sets this connection's auto-commit mode. If a connection is in auto-commit mode, then all its SQL statements will be executed and committed as individual transactions. Otherwise, its SQL statements are grouped into transactions that are terminated by a call to either the method `commit` or the method `rollback`. By default, new connections are in auto-commit mode. The commit occurs when the statement completes or the next execute occurs, whichever comes first. In the case of statements returning a ResultSet, the statement completes when the last row of the ResultSet has been retrieved or the ResultSet has been closed. In advanced cases, a single statement may return multiple results as well as output parameter values. In these cases the commit occurs when all results and output parameter values have been retrieved.

  Specified by:
    `setAutoCommit` in interface `Connection`
  Parameters:
    `autoCommit` - true enables auto-commit; false disables auto-commit.
  Throws:
    `SQLException` - if a database access error occurs

### setManagedEnvironment

    public void setManagedEnvironment(boolean managedConnection)
                               throws SQLException

  Throws:
    `SQLException`

### getAutoCommit

    public boolean getAutoCommit()
                          throws SQLException

  Gets the current auto-commit state.

  Specified by:
    `getAutoCommit` in interface `Connection`
  Returns:
    the current state of auto-commit mode
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `setAutoCommit(boolean)`

### commit

    public void commit()
                throws SQLException

  Makes all changes made since the previous commit/rollback permanent and releases any database locks currently held by the Connection. This method should be used only when auto-commit mode has been disabled.

  Specified by:
    `commit` in interface `Connection`
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `setAutoCommit(boolean)`

### rollback

    public void rollback()
                  throws SQLException

  Drops all changes made since the previous commit/rollback and releases any database locks currently held by this Connection. This method should be used only when auto- commit has been disabled.

  Specified by:
    `rollback` in interface `Connection`
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `setAutoCommit(boolean)`

### close

    public void close()
               throws SQLException

  Releases a Connection's database and JDBC resources immediately instead of waiting for them to be automatically released.

  Note: A Connection is automatically closed when it is garbage collected. Certain fatal errors also result in a closed Connection.

  Specified by:
    `close` in interface `Connection`
  Throws:
    `SQLException` - if a database access error occurs

### isClosed

    public boolean isClosed()

  Tests to see if a Connection is closed.

  Specified by:
    `isClosed` in interface `Connection`
  Returns:
    true if the connection is closed; false if it's still open

### getMetaData

    public DatabaseMetaData getMetaData()
                                 throws SQLException

  Gets the metadata regarding this connection's database. A Connection's database is able to provide information describing its tables, its supported SQL grammar, its stored procedures, the capabilities of this connection, and so on. This information is made available through a DatabaseMetaData object.

  Specified by:
    `getMetaData` in interface `Connection`
  Returns:
    a DatabaseMetaData object for this Connection
  Throws:
    `SQLException` - if a database access error occurs

### setReadOnly

    public void setReadOnly(boolean readOnly)
                     throws SQLException

  Puts this connection in read-only mode as a hint to enable database optimizations.

  Note: This method cannot be called while in the middle of a transaction.

  Specified by:
    `setReadOnly` in interface `Connection`
  Parameters:
    `readOnly` - true enables read-only mode; false disables read-only mode.
  Throws:
    `SQLException` - if a database access error occurs

### isReadOnly

    public boolean isReadOnly()
                       throws SQLException

  Tests to see if the connection is in read-only mode.

  Specified by:
    `isReadOnly` in interface `Connection`
  Returns:
    true if connection is read-only and false otherwise
  Throws:
    `SQLException` - if a database access error occurs

### setCatalog

    public void setCatalog(String catalog)
                    throws SQLException

  Sets a catalog name in order to select a subspace of this Connection's database in which to work. If the driver does not support catalogs, it will silently ignore this request.

  Specified by:
    `setCatalog` in interface `Connection`
  Throws:
    `SQLException` - if a database access error occurs

### getCatalog

    public String getCatalog()
                      throws SQLException

  Returns the Connection's current catalog name.

  Specified by:
    `getCatalog` in interface `Connection`
  Returns:
    the current catalog name or null
  Throws:
    `SQLException` - if a database access error occurs

### setTransactionIsolation

    public void setTransactionIsolation(int level)
                                 throws SQLException

  Attempts to change the transaction isolation level to the one given. The constants defined in the interface `Connection` are the possible transaction isolation levels.

  Calling this method will commit any current transaction.

  Specified by:
    `setTransactionIsolation` in interface `Connection`
  Parameters:
    `level` - one of the TRANSACTION_* isolation values with the exception of TRANSACTION_NONE; some databases may not support other values
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `DatabaseMetaData.supportsTransactionIsolationLevel(int)`

### getTransactionIsolation

    public int getTransactionIsolation()
                                throws SQLException

  Gets this Connection's current transaction isolation level.

  Specified by:
    `getTransactionIsolation` in interface `Connection`
  Returns:
    the current TRANSACTION_* mode value
  Throws:
    `SQLException` - if a database access error occurs

### getWarnings

    public SQLWarning getWarnings()
                           throws SQLException

  Returns the first warning reported by calls on this Connection.

  Note: Subsequent warnings will be chained to this SQLWarning.

  Specified by:
    `getWarnings` in interface `Connection`
  Returns:
    the first SQLWarning or null
  Throws:
    `SQLException` - if a database access error occurs

### clearWarnings

    public void clearWarnings()
                       throws SQLException

  Clears all warnings reported for this `Connection` object. After a call to this method, the method `getWarnings` returns null until a new warning is reported for this Connection.

  Specified by:
    `clearWarnings` in interface `Connection`
  Throws:
    `SQLException` - if a database access error occurs

### createStatement

    public Statement createStatement(int resultSetType,
                                     int resultSetConcurrency)
                              throws SQLException

  Creates a `Statement` object that will generate `ResultSet` objects with the given type and concurrency. This method is the same as the `createStatement` method above, but it allows the default result set type and result set concurrency type to be overridden.

  Specified by:
    `createStatement` in interface `Connection`
  Parameters:
    `resultSetType` - a result set type; see ResultSet.TYPE_XXX
    `resultSetConcurrency` - a concurrency type; see ResultSet.CONCUR_XXX
  Returns:
    a new Statement object
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### createStatement

    public Statement createStatement(int resultSetType,
                                     int resultSetConcurrency,
                                     int resultSetHoldability)
                              throws SQLException

  Creates a `Statement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability. This method is the same as the `createStatement` method above, but it allows the default result set type, concurrency, and holdability to be overridden.

  Specified by:
    `createStatement` in interface `Connection`
  Parameters:
    `resultSetType` - one of the following `ResultSet` constants: `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
    `resultSetConcurrency` - one of the following `ResultSet` constants: `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
    `resultSetHoldability` - one of the following `ResultSet` constants: `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
  Returns:
    a new `Statement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability
  Throws:
    `SQLException` - if a database access error occurs or the given parameters are not `ResultSet` constants indicating type, concurrency, and holdability
  Since:
    1.4
  See Also:
    `ResultSet`

### prepareStatement

    public PreparedStatement prepareStatement(String sql,
                                              int resultSetType,
                                              int resultSetConcurrency)
                                       throws SQLException

  Creates a `PreparedStatement` object that will generate `ResultSet` objects with the given type and concurrency. This method is the same as the `prepareStatement` method above, but it allows the default result set type and result set concurrency type to be overridden.

  Specified by:
    `prepareStatement` in interface `Connection`
  Parameters:
    `resultSetType` - a result set type; see ResultSet.TYPE_XXX
    `resultSetConcurrency` - a concurrency type; see ResultSet.CONCUR_XXX
  Returns:
    a new PreparedStatement object containing the pre-compiled SQL statement
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### prepareStatement

    public PreparedStatement prepareStatement(String sql,
                                              int resultSetType,
                                              int resultSetConcurrency,
                                              int resultSetHoldability)
                                       throws SQLException

  Specified by:
    `prepareStatement` in interface `Connection`
  Throws:
    `SQLException`

### prepareStatement

    public PreparedStatement prepareStatement(String sql,
                                              int resultSetType,
                                              int resultSetConcurrency,
                                              int resultSetHoldability,
                                              boolean metaData)
                                       throws SQLException

  Throws:
    `SQLException`

### prepareCall

    public CallableStatement prepareCall(String sql,
                                         int resultSetType,
                                         int resultSetConcurrency)
                                  throws SQLException

  Creates a `CallableStatement` object that will generate `ResultSet` objects with the given type and concurrency. This method is the same as the `prepareCall` method above, but it allows the default result set type and result set concurrency type to be overridden.

  Specified by:
    `prepareCall` in interface `Connection`
  Parameters:
    `resultSetType` - a result set type; see ResultSet.TYPE_XXX
    `resultSetConcurrency` - a concurrency type; see ResultSet.CONCUR_XXX
  Returns:
    a new CallableStatement object containing the pre-compiled SQL statement
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### prepareCall

    public CallableStatement prepareCall(String sql,
                                         int resultSetType,
                                         int resultSetConcurrency,
                                         int resultSetHoldability)
                                  throws SQLException

  Specified by:
    `prepareCall` in interface `Connection`
  Throws:
    `SQLException`

### getTypeMap

    public Map getTypeMap()
                   throws SQLException

  Gets the type map object associated with this connection. Unless the application has added an entry to the type map, the map returned will be empty.

  Specified by:
    `getTypeMap` in interface `Connection`
  Returns:
    the `java.util.Map` object associated with this `Connection` object
  Throws:
    `SQLException`
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### setTypeMap

    public void setTypeMap(Map map)
                    throws SQLException

  Installs the given type map as the type map for this connection. The type map will be used for the custom mapping of SQL structured types and distinct types.

  Specified by:
    `setTypeMap` in interface `Connection`
  Parameters:
    `map` - the `java.util.Map` object to install as the replacement for this `Connection` object's default type map
  Throws:
    `SQLException`
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### setFirebirdSavepoint

    public FirebirdSavepoint setFirebirdSavepoint()
                                           throws SQLException

  Creates an unnamed savepoint in the current transaction and returns the new `Savepoint` object that represents it.

  Specified by:
    `setFirebirdSavepoint` in interface `FirebirdConnection`
  Returns:
    the new `Savepoint` object
  Throws:
    `SQLException` - if a database access error occurs or this `Connection` object is currently in auto-commit mode
  See Also:
    `Savepoint`

### setFirebirdSavepoint

    public FirebirdSavepoint setFirebirdSavepoint(String name)
                                           throws SQLException

  Creates a savepoint with the given name in the current transaction and returns the new `Savepoint` object that represents it.

  Specified by:
    `setFirebirdSavepoint` in interface `FirebirdConnection`
  Parameters:
    `name` - a `String` containing the name of the savepoint
  Returns:
    the new `Savepoint` object
  Throws:
    `SQLException` - if a database access error occurs or this `Connection` object is currently in auto-commit mode
  See Also:
    `Savepoint`

### rollback

    public void rollback(FirebirdSavepoint savepoint)
                  throws SQLException

  Undoes all changes made after the given `Savepoint` object was set.

  This method should be used only when auto-commit has been disabled.

  Specified by:
    `rollback` in interface `FirebirdConnection`
  Parameters:
    `savepoint` - the `Savepoint` object to roll back to
  Throws:
    `SQLException` - if a database access error occurs, the `Savepoint` object is no longer valid, or this `Connection` object is currently in auto-commit mode
  See Also:
    `Savepoint`, `rollback()`

### releaseSavepoint

    public void releaseSavepoint(FirebirdSavepoint savepoint)
                          throws SQLException

  Removes the given `Savepoint` object from the current transaction. Any reference to the savepoint after it have been removed will cause an `SQLException` to be thrown.

  Specified by:
    `releaseSavepoint` in interface `FirebirdConnection`
  Parameters:
    `savepoint` - the `Savepoint` object to be removed
  Throws:
    `SQLException` - if a database access error occurs or the given `Savepoint` object is not a valid savepoint in the current transaction

### invalidateSavepoints

    protected void invalidateSavepoints()

  Invalidate all savepoints.

### getLocalTransaction

    public FirebirdLocalTransaction getLocalTransaction()

  Returns a FBLocalTransaction instance that enables a component to demarcate resource manager local transactions on this connection.

### createBlob

    public Blob createBlob()
                    throws SQLException

  This non-interface method is included so you can actually get a blob object to use to write new data into a blob field without needing a preexisting blob to modify.

  Specified by:
    `createBlob` in interface `Connection`
  Specified by:
    `createBlob` in interface `FirebirdConnection`
  Returns:
    instance of `FirebirdBlob`.
  Throws:
    `SQLException` - if something went wrong.

### inTransaction

    public boolean inTransaction()
                          throws SQLException

  Check if this connection is currently involved in a transaction

  Throws:
    `SQLException`

### getIscEncoding

    public String getIscEncoding()
                          throws SQLException

  Get the encoding that is being used for this connection.

  Specified by:
    `getIscEncoding` in interface `FirebirdConnection`
  Returns:
    The name of the encoding used
  Throws:
    `SQLException`

### addWarning

    protected void addWarning(SQLWarning warning)

### getGDSHelper

    public GDSHelper getGDSHelper()
                           throws GDSException

  Throws:
    `GDSException`

### finalize

    protected void finalize()
                     throws Throwable

  Overrides:
    `finalize` in class `Object`
  Throws:
    `Throwable`

Copyright © 2001-2010. All Rights Reserved.